# sage_setup: distribution = sagemath-flint
# distutils: libraries = flint
# distutils: depends = flint/gr_mat.h

################################################################################
# This file is auto-generated by the script
#   SAGE_ROOT/src/sage_setup/autogen/flint_autogen.py.
# From the commit 3e2c3a3e091106a25ca9c6fba28e02f2cbcd654a
# Do not modify by hand! Fix and rerun the script instead.
################################################################################

from libc.stdio cimport FILE
from sage.libs.gmp.types cimport *
from sage.libs.mpfr.types cimport *
from sage.libs.flint.types cimport *

cdef extern from "flint_wrap.h":
    gr_ptr gr_mat_entry_ptr(gr_mat_t mat, slong i, slong j, gr_ctx_t ctx) noexcept
    void gr_mat_init(gr_mat_t mat, slong rows, slong cols, gr_ctx_t ctx) noexcept
    int gr_mat_init_set(gr_mat_t res, const gr_mat_t mat, gr_ctx_t ctx) noexcept
    void gr_mat_clear(gr_mat_t mat, gr_ctx_t ctx) noexcept
    void gr_mat_swap(gr_mat_t mat1, gr_mat_t mat2, gr_ctx_t ctx) noexcept
    int gr_mat_swap_entrywise(gr_mat_t mat1, const gr_mat_t mat2, gr_ctx_t ctx) noexcept
    void gr_mat_window_init(gr_mat_t window, const gr_mat_t mat, slong r1, slong c1, slong r2, slong c2, gr_ctx_t ctx) noexcept
    void gr_mat_window_clear(gr_mat_t window, gr_ctx_t ctx) noexcept
    int gr_mat_write(gr_stream_t out, const gr_mat_t mat, gr_ctx_t ctx) noexcept
    int gr_mat_print(const gr_mat_t mat, gr_ctx_t ctx) noexcept
    truth_t gr_mat_equal(const gr_mat_t mat1, const gr_mat_t mat2, gr_ctx_t ctx) noexcept
    truth_t gr_mat_is_zero(const gr_mat_t mat, gr_ctx_t ctx) noexcept
    truth_t gr_mat_is_one(const gr_mat_t mat, gr_ctx_t ctx) noexcept
    truth_t gr_mat_is_neg_one(const gr_mat_t mat, gr_ctx_t ctx) noexcept
    truth_t gr_mat_is_scalar(const gr_mat_t mat, gr_ctx_t ctx) noexcept
    int gr_mat_zero(gr_mat_t res, gr_ctx_t ctx) noexcept
    int gr_mat_one(gr_mat_t res, gr_ctx_t ctx) noexcept
    int gr_mat_set(gr_mat_t res, const gr_mat_t mat, gr_ctx_t ctx) noexcept
    int gr_mat_set_fmpz_mat(gr_mat_t res, const fmpz_mat_t mat, gr_ctx_t ctx) noexcept
    int gr_mat_set_fmpq_mat(gr_mat_t res, const fmpq_mat_t mat, gr_ctx_t ctx) noexcept
    int gr_mat_set_scalar(gr_mat_t res, gr_srcptr c, gr_ctx_t ctx) noexcept
    int gr_mat_set_ui(gr_mat_t res, ulong c, gr_ctx_t ctx) noexcept
    int gr_mat_set_si(gr_mat_t res, slong c, gr_ctx_t ctx) noexcept
    int gr_mat_set_fmpz(gr_mat_t res, const fmpz_t c, gr_ctx_t ctx) noexcept
    int gr_mat_set_fmpq(gr_mat_t res, const fmpq_t c, gr_ctx_t ctx) noexcept
    int gr_mat_concat_horizontal(gr_mat_t res, const gr_mat_t mat1, const gr_mat_t mat2, gr_ctx_t ctx) noexcept
    int gr_mat_concat_vertical(gr_mat_t res, const gr_mat_t mat1, const gr_mat_t mat2, gr_ctx_t ctx) noexcept
    int gr_mat_transpose(gr_mat_t B, const gr_mat_t A, gr_ctx_t ctx) noexcept
    int gr_mat_swap_rows(gr_mat_t mat, slong * perm, slong r, slong s, gr_ctx_t ctx) noexcept
    int gr_mat_swap_cols(gr_mat_t mat, slong * perm, slong r, slong s, gr_ctx_t ctx) noexcept
    int gr_mat_invert_rows(gr_mat_t mat, slong * perm, gr_ctx_t ctx) noexcept
    int gr_mat_invert_cols(gr_mat_t mat, slong * perm, gr_ctx_t ctx) noexcept
    truth_t gr_mat_is_empty(const gr_mat_t mat, gr_ctx_t ctx) noexcept
    truth_t gr_mat_is_square(const gr_mat_t mat, gr_ctx_t ctx) noexcept
    int gr_mat_neg(gr_mat_t res, const gr_mat_t mat, gr_ctx_t ctx) noexcept
    int gr_mat_add(gr_mat_t res, const gr_mat_t mat1, const gr_mat_t mat2, gr_ctx_t ctx) noexcept
    int gr_mat_sub(gr_mat_t res, const gr_mat_t mat1, const gr_mat_t mat2, gr_ctx_t ctx) noexcept
    int gr_mat_mul_classical(gr_mat_t res, const gr_mat_t mat1, const gr_mat_t mat2, gr_ctx_t ctx) noexcept
    int gr_mat_mul_strassen(gr_mat_t C, const gr_mat_t A, const gr_mat_t B, gr_ctx_t ctx) noexcept
    int gr_mat_mul_generic(gr_mat_t C, const gr_mat_t A, const gr_mat_t B, gr_ctx_t ctx) noexcept
    int gr_mat_mul(gr_mat_t res, const gr_mat_t mat1, const gr_mat_t mat2, gr_ctx_t ctx) noexcept
    int gr_mat_sqr(gr_mat_t res, const gr_mat_t mat, gr_ctx_t ctx) noexcept
    int gr_mat_add_scalar(gr_mat_t res, const gr_mat_t mat, gr_srcptr c, gr_ctx_t ctx) noexcept
    int gr_mat_sub_scalar(gr_mat_t res, const gr_mat_t mat, gr_srcptr c, gr_ctx_t ctx) noexcept
    int gr_mat_mul_scalar(gr_mat_t res, const gr_mat_t mat, gr_srcptr c, gr_ctx_t ctx) noexcept
    int gr_mat_addmul_scalar(gr_mat_t res, const gr_mat_t mat, gr_srcptr c, gr_ctx_t ctx) noexcept
    int gr_mat_submul_scalar(gr_mat_t res, const gr_mat_t mat, gr_srcptr c, gr_ctx_t ctx) noexcept
    int gr_mat_div_scalar(gr_mat_t res, const gr_mat_t mat, gr_srcptr c, gr_ctx_t ctx) noexcept
    int _gr_mat_gr_poly_evaluate(gr_mat_t res, gr_srcptr poly, slong len, const gr_mat_t mat, gr_ctx_t ctx) noexcept
    int gr_mat_gr_poly_evaluate(gr_mat_t res, const gr_poly_t poly, const gr_mat_t mat, gr_ctx_t ctx) noexcept
    truth_t gr_mat_is_upper_triangular(const gr_mat_t mat, gr_ctx_t ctx) noexcept
    truth_t gr_mat_is_lower_triangular(const gr_mat_t mat, gr_ctx_t ctx) noexcept
    truth_t gr_mat_is_diagonal(const gr_mat_t mat, gr_ctx_t ctx) noexcept
    int gr_mat_mul_diag(gr_mat_t res, const gr_mat_t A, const gr_vec_t D, gr_ctx_t ctx) noexcept
    int gr_mat_diag_mul(gr_mat_t res, const gr_vec_t D, const gr_mat_t A, gr_ctx_t ctx) noexcept
    int gr_mat_find_nonzero_pivot_large_abs(slong * pivot_row, gr_mat_t mat, slong start_row, slong end_row, slong column, gr_ctx_t ctx) noexcept
    int gr_mat_find_nonzero_pivot_generic(slong * pivot_row, gr_mat_t mat, slong start_row, slong end_row, slong column, gr_ctx_t ctx) noexcept
    int gr_mat_find_nonzero_pivot(slong * pivot_row, gr_mat_t mat, slong start_row, slong end_row, slong column, gr_ctx_t ctx) noexcept
    int gr_mat_lu_classical(slong * rank, slong * P, gr_mat_t LU, const gr_mat_t A, int rank_check, gr_ctx_t ctx) noexcept
    int gr_mat_lu_recursive(slong * rank, slong * P, gr_mat_t LU, const gr_mat_t A, int rank_check, gr_ctx_t ctx) noexcept
    int gr_mat_lu(slong * rank, slong * P, gr_mat_t LU, const gr_mat_t A, int rank_check, gr_ctx_t ctx) noexcept
    int gr_mat_fflu(slong * rank, slong * P, gr_mat_t LU, gr_ptr den, const gr_mat_t A, int rank_check, gr_ctx_t ctx) noexcept
    int gr_mat_nonsingular_solve_tril_classical(gr_mat_t X, const gr_mat_t L, const gr_mat_t B, int unit, gr_ctx_t ctx) noexcept
    int gr_mat_nonsingular_solve_tril_recursive(gr_mat_t X, const gr_mat_t L, const gr_mat_t B, int unit, gr_ctx_t ctx) noexcept
    int gr_mat_nonsingular_solve_tril(gr_mat_t X, const gr_mat_t L, const gr_mat_t B, int unit, gr_ctx_t ctx) noexcept
    int gr_mat_nonsingular_solve_triu_classical(gr_mat_t X, const gr_mat_t U, const gr_mat_t B, int unit, gr_ctx_t ctx) noexcept
    int gr_mat_nonsingular_solve_triu_recursive(gr_mat_t X, const gr_mat_t U, const gr_mat_t B, int unit, gr_ctx_t ctx) noexcept
    int gr_mat_nonsingular_solve_triu(gr_mat_t X, const gr_mat_t U, const gr_mat_t B, int unit, gr_ctx_t ctx) noexcept
    int gr_mat_nonsingular_solve_fflu(gr_mat_t X, const gr_mat_t A, const gr_mat_t B, gr_ctx_t ctx) noexcept
    int gr_mat_nonsingular_solve_lu(gr_mat_t X, const gr_mat_t A, const gr_mat_t B, gr_ctx_t ctx) noexcept
    int gr_mat_nonsingular_solve(gr_mat_t X, const gr_mat_t A, const gr_mat_t B, gr_ctx_t ctx) noexcept
    int gr_mat_nonsingular_solve_fflu_precomp(gr_mat_t X, const slong * perm, const gr_mat_t LU, const gr_mat_t B, gr_ctx_t ctx) noexcept
    int gr_mat_nonsingular_solve_lu_precomp(gr_mat_t X, const slong * perm, const gr_mat_t LU, const gr_mat_t B, gr_ctx_t ctx) noexcept
    int gr_mat_nonsingular_solve_den_fflu(gr_mat_t X, gr_ptr den, const gr_mat_t A, const gr_mat_t B, gr_ctx_t ctx) noexcept
    int gr_mat_nonsingular_solve_den(gr_mat_t X, gr_ptr den, const gr_mat_t A, const gr_mat_t B, gr_ctx_t ctx) noexcept
    int gr_mat_solve_field(gr_mat_t X, const gr_mat_t A, const gr_mat_t B, gr_ctx_t ctx) noexcept
    int gr_mat_det_fflu(gr_ptr res, const gr_mat_t mat, gr_ctx_t ctx) noexcept
    int gr_mat_det_berkowitz(gr_ptr res, const gr_mat_t mat, gr_ctx_t ctx) noexcept
    int gr_mat_det_lu(gr_ptr res, const gr_mat_t mat, gr_ctx_t ctx) noexcept
    int gr_mat_det_cofactor(gr_ptr res, const gr_mat_t mat, gr_ctx_t ctx) noexcept
    int gr_mat_det_generic_field(gr_ptr res, const gr_mat_t A, gr_ctx_t ctx) noexcept
    int gr_mat_det_generic_integral_domain(gr_ptr res, const gr_mat_t A, gr_ctx_t ctx) noexcept
    int gr_mat_det_generic(gr_ptr res, const gr_mat_t A, gr_ctx_t ctx) noexcept
    int gr_mat_det(gr_ptr res, const gr_mat_t mat, gr_ctx_t ctx) noexcept
    int gr_mat_trace(gr_ptr res, const gr_mat_t mat, gr_ctx_t ctx) noexcept
    int gr_mat_rank_fflu(slong * rank, const gr_mat_t mat, gr_ctx_t ctx) noexcept
    int gr_mat_rank_lu(slong * rank, const gr_mat_t mat, gr_ctx_t ctx) noexcept
    int gr_mat_rank(slong * rank, const gr_mat_t mat, gr_ctx_t ctx) noexcept
    int gr_mat_rref_lu(slong * rank, gr_mat_t R, const gr_mat_t A, gr_ctx_t ctx) noexcept
    int gr_mat_rref_fflu(slong * rank, gr_mat_t R, const gr_mat_t A, gr_ctx_t ctx) noexcept
    int gr_mat_rref(slong * rank, gr_mat_t R, const gr_mat_t A, gr_ctx_t ctx) noexcept
    int gr_mat_rref_den_fflu(slong * rank, gr_mat_t R, gr_ptr den, const gr_mat_t A, gr_ctx_t ctx) noexcept
    int gr_mat_rref_den(slong * rank, gr_mat_t R, gr_ptr den, const gr_mat_t A, gr_ctx_t ctx) noexcept
    int gr_mat_nullspace(gr_mat_t X, const gr_mat_t A, gr_ctx_t ctx) noexcept
    int gr_mat_inv(gr_mat_t res, const gr_mat_t mat, gr_ctx_t ctx) noexcept
    int gr_mat_adjugate_charpoly(gr_mat_t adj, gr_ptr det, const gr_mat_t mat, gr_ctx_t ctx) noexcept
    int gr_mat_adjugate_cofactor(gr_mat_t adj, gr_ptr det, const gr_mat_t mat, gr_ctx_t ctx) noexcept
    int gr_mat_adjugate(gr_mat_t adj, gr_ptr det, const gr_mat_t mat, gr_ctx_t ctx) noexcept
    int _gr_mat_charpoly(gr_ptr res, const gr_mat_t mat, gr_ctx_t ctx) noexcept
    int gr_mat_charpoly(gr_poly_t res, const gr_mat_t mat, gr_ctx_t ctx) noexcept
    int _gr_mat_charpoly_berkowitz(gr_ptr res, const gr_mat_t mat, gr_ctx_t ctx) noexcept
    int gr_mat_charpoly_berkowitz(gr_poly_t res, const gr_mat_t mat, gr_ctx_t ctx) noexcept
    int _gr_mat_charpoly_danilevsky_inplace(gr_ptr res, gr_mat_t mat, gr_ctx_t ctx) noexcept
    int _gr_mat_charpoly_danilevsky(gr_ptr res, const gr_mat_t mat, gr_ctx_t ctx) noexcept
    int gr_mat_charpoly_danilevsky(gr_poly_t res, const gr_mat_t mat, gr_ctx_t ctx) noexcept
    int _gr_mat_charpoly_gauss(gr_ptr res, const gr_mat_t mat, gr_ctx_t ctx) noexcept
    int gr_mat_charpoly_gauss(gr_poly_t res, const gr_mat_t mat, gr_ctx_t ctx) noexcept
    int _gr_mat_charpoly_householder(gr_ptr res, const gr_mat_t mat, gr_ctx_t ctx) noexcept
    int gr_mat_charpoly_householder(gr_poly_t res, const gr_mat_t mat, gr_ctx_t ctx) noexcept
    int _gr_mat_charpoly_faddeev(gr_ptr res, gr_mat_t adj, const gr_mat_t mat, gr_ctx_t ctx) noexcept
    int gr_mat_charpoly_faddeev(gr_poly_t res, gr_mat_t adj, const gr_mat_t mat, gr_ctx_t ctx) noexcept
    int _gr_mat_charpoly_faddeev_bsgs(gr_ptr res, gr_mat_t adj, const gr_mat_t mat, gr_ctx_t ctx) noexcept
    int gr_mat_charpoly_faddeev_bsgs(gr_poly_t res, gr_mat_t adj, const gr_mat_t mat, gr_ctx_t ctx) noexcept
    int _gr_mat_charpoly_from_hessenberg(gr_ptr res, const gr_mat_t mat, gr_ctx_t ctx) noexcept
    int gr_mat_charpoly_from_hessenberg(gr_poly_t res, const gr_mat_t mat, gr_ctx_t ctx) noexcept
    int gr_mat_minpoly_field(gr_poly_t res, const gr_mat_t mat, gr_ctx_t ctx) noexcept
    int gr_mat_apply_row_similarity(gr_mat_t M, slong r, gr_ptr d, gr_ctx_t ctx) noexcept
    int gr_mat_eigenvalues(gr_vec_t lmbda, gr_vec_t mult, const gr_mat_t mat, int flags, gr_ctx_t ctx) noexcept
    int gr_mat_eigenvalues_other(gr_vec_t lmbda, gr_vec_t mult, const gr_mat_t mat, gr_ctx_t mat_ctx, int flags, gr_ctx_t ctx) noexcept
    int gr_mat_diagonalization_precomp(gr_vec_t D, gr_mat_t L, gr_mat_t R, const gr_mat_t A, const gr_vec_t eigenvalues, const gr_vec_t mult, gr_ctx_t ctx) noexcept
    int gr_mat_diagonalization_generic(gr_vec_t D, gr_mat_t L, gr_mat_t R, const gr_mat_t A, int flags, gr_ctx_t ctx) noexcept
    int gr_mat_diagonalization(gr_vec_t D, gr_mat_t L, gr_mat_t R, const gr_mat_t A, int flags, gr_ctx_t ctx) noexcept
    int gr_mat_set_jordan_blocks(gr_mat_t mat, const gr_vec_t lmbda, slong num_blocks, slong * block_lambda, slong * block_size, gr_ctx_t ctx) noexcept
    int gr_mat_jordan_blocks(gr_vec_t lmbda, slong * num_blocks, slong * block_lambda, slong * block_size, const gr_mat_t A, gr_ctx_t ctx) noexcept
    int gr_mat_jordan_transformation(gr_mat_t mat, const gr_vec_t lmbda, slong num_blocks, slong * block_lambda, slong * block_size, const gr_mat_t A, gr_ctx_t ctx) noexcept
    int gr_mat_jordan_form(gr_mat_t J, gr_mat_t P, const gr_mat_t A, gr_ctx_t ctx) noexcept
    int gr_mat_exp_jordan(gr_mat_t res, const gr_mat_t A, gr_ctx_t ctx) noexcept
    int gr_mat_exp(gr_mat_t res, const gr_mat_t A, gr_ctx_t ctx) noexcept
    int gr_mat_log_jordan(gr_mat_t res, const gr_mat_t A, gr_ctx_t ctx) noexcept
    int gr_mat_log(gr_mat_t res, const gr_mat_t A, gr_ctx_t ctx) noexcept
    truth_t gr_mat_is_hessenberg(const gr_mat_t mat, gr_ctx_t ctx) noexcept
    int gr_mat_hessenberg_gauss(gr_mat_t res, const gr_mat_t mat, gr_ctx_t ctx) noexcept
    int gr_mat_hessenberg_householder(gr_mat_t res, const gr_mat_t mat, gr_ctx_t ctx) noexcept
    int gr_mat_hessenberg(gr_mat_t res, const gr_mat_t mat, gr_ctx_t ctx) noexcept
    int gr_mat_randtest(gr_mat_t res, flint_rand_t state, gr_ctx_t ctx) noexcept
    int gr_mat_randops(gr_mat_t mat, flint_rand_t state, slong count, gr_ctx_t ctx) noexcept
    int gr_mat_randpermdiag(int * parity, gr_mat_t mat, flint_rand_t state, gr_ptr diag, slong n, gr_ctx_t ctx) noexcept
    int gr_mat_randrank(gr_mat_t mat, flint_rand_t state, slong rank, gr_ctx_t ctx) noexcept
    int gr_mat_ones(gr_mat_t res, gr_ctx_t ctx) noexcept
    int gr_mat_pascal(gr_mat_t res, int triangular, gr_ctx_t ctx) noexcept
    int gr_mat_stirling(gr_mat_t res, int kind, gr_ctx_t ctx) noexcept
    int gr_mat_hilbert(gr_mat_t res, gr_ctx_t ctx) noexcept
    int gr_mat_hadamard(gr_mat_t res, gr_ctx_t ctx) noexcept
    int gr_mat_reduce_row(slong * column, gr_mat_t A, slong * P, slong * L, slong m, gr_ctx_t ctx) noexcept
